; 
; Assemble and link as a console app so print will work.
; 
    include \masm32\include\masm32rt.inc
; 

loword MACRO arg
    IFNDEF __loword_macro_return_var__
      .data
        __loword_macro_return_var__ dd 0
      .code
    ENDIF
    push arg
    pop __loword_macro_return_var__
    and __loword_macro_return_var__, 0ffffh
    EXITM <__loword_macro_return_var__>
ENDM

hiword MACRO arg
    IFNDEF __hiword_macro_return_var__
      .data
        __hiword_macro_return_var__ dd 0
      .code
    ENDIF
    push arg
    pop __hiword_macro_return_var__
    shr __hiword_macro_return_var__, 16
    EXITM <__hiword_macro_return_var__>
ENDM

; 

inpoly PROTO C pPoints:DWORD, nPoints:DWORD, x:DWORD, y:DWORD

;int                                /*   1=inside, 0=outside                */
;inpoly(                            /* is target point inside a 2D polygon? */
;unsigned int poly[][2],            /*   polygon points, [0]=x, [1]=y       */
;int npoints,                       /*   number of points in polygon        */
;unsigned int xt,                   /*   x (horizontal) of target point     */
;unsigned int yt)                   /*   y (vertical) of target point

; 

    .data
      hInstance dd 0
      hrgn      dd 0
      points    POINT {10,10},{230,60},{200,150},{160,5},{120,140},{100,10},{30,140}
    .code

; 

DlgProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL ps:PAINTSTRUCT

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke CreatePolygonRgn, ADDR points, 7, WINDING ;ALTERNATE
        mov hrgn, eax

      CASE WM_MOUSEMOVE

        invoke PtInRegion, hrgn, loword(lParam), hiword(lParam)
        print str$(eax),9
        invoke inpoly, ADDR points, 7, loword(lParam), hiword(lParam)
        print str$(eax),13,10

      CASE WM_CTLCOLORDLG

        invoke GetStockObject, WHITE_BRUSH
        ret

      CASE WM_PAINT

        invoke BeginPaint, hwndDlg, ADDR ps

        invoke GetStockObject, BLACK_BRUSH

        invoke SelectObject, ps.hdc, eax

        invoke PaintRgn, ps.hdc, hrgn

        invoke EndPaint, hwndDlg, ADDR ps

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

       invoke EndDialog, hwndDlg, 0

    ENDSW
    return 0

DlgProc endp

; 

start:

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Test","MS Sans Serif",10, \
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
            0,0,0,100,75,1024

    CallModalDialog hInstance,0,DlgProc,NULL

    exit

; 
end start

